#ifndef DEVICE_H_
#define DEVICE_H_

#include <QMap>
#include <QString>

class Device
{
	protected:
	
		QString name;
		QString type;
	
	public:
		static const QString ANY;
		static const QString FALLBACK;
		static const QString NONE; // for devs that don't need to process things
		
		Device(QString name, QString type) {
			this->name = name;
			this->type = type;
		}
		
		virtual ~Device() {}
		
		virtual const QString& getType() {
			return type;
		}
		virtual const QString& getName() {
			return name;
		}
		
		virtual void process(QMap<QString, QString>* ) {
			// default: nothing
		}
		
		// test if this device can deal with a message type (like SEN or CONF)
		virtual bool acceptsMsg(QString ) {
			return false;
		}
};

#endif /*DEVICE_H_*/
