#ifndef NAVAGENT_H
#define NAVAGENT_H

#include <QImage>
#include <QImageWriter>

#include "Agent.h"

#include "PositionActuator.h"
#include "KeyboardSensor.h"
#include "Navigator.h"

#include "SonarSensor.h"
#include "RFIDSensor.h"
#include "VictimRFIDSensor.h"


class NavAgent : public Agent {

private:

public:

	NavAgent();
	virtual ~NavAgent();

    virtual void configure(QString model, QString name, QString position, QString rotation);


protected:

    virtual void notifyUpdate(Sensor* sensor);

    virtual void observed(SonarData sonar);
    virtual void observed(QMap<QString, RFIDData> rfid);
    virtual void observed(QMap<QString, VictimRFIDData> rfid);


private:

    PositionActuator* position;
    KeyboardSensor*   keyboard;
    Navigator*        navigator;

    SonarSensor*      sonar;
    RFIDSensor*       rfid;
    VictimRFIDSensor* victimrfid;

};

#endif
