#ifndef SENSOR_H
#define SENSOR_H

#include <QMap>
#include <QString>

class Agent;

class Sensor
{
public:
	//static const QString ANYTYPE;
	static const QString ANYNAME;

    Sensor(QString type, QString name);
	virtual ~Sensor();
	
	QString getType();
	QString getName();

    virtual void setAgent(Agent* agent);

    virtual void accept(QMap<QString, QString>* /* msg */) {}


protected:

	Agent*  agent;
	QString type;
	QString name;

	bool needsConfiguration;

	bool isConfMessage(QMap<QString, QString>* msg);
    bool isSensorMessage(QMap<QString, QString>* msg);
    bool isResponseMessage(QMap<QString, QString>* msg);

    bool isStatusOK(QMap<QString, QString>* msg);
    bool isStatusFail(QMap<QString, QString>* msg);

	double getDouble(QMap<QString, QString>*, QString);
	float getFloat(QMap<QString, QString>*, QString);

    void sendSetCommand(QString opCode);
    void sendGetConf();

};

#endif
