#include "KeyboardSensor.h"
#include "Agent.h"

#include <iostream>

KeyboardSensor::KeyboardSensor() : Sensor("Keyboard", "Keyboard") {
	speed = 1;
}

KeyboardSensor::~KeyboardSensor() {}

void KeyboardSensor::run() {

	bool keepHandling = true;
	char key;

	while (keepHandling) {

		std::cin >> key;

		switch(key) {

			case 'w':
				drive(speed*.5, 0); 
                break;
			case 'a':
				drive(0, speed*.3); 
                break;
			case 's':
				drive(speed*-.5, 0); 
                break;
			case 'd':
				drive(0, speed*-.3); 
                break;
                
             case 'x':
                 speedUp(); 
                 break;
             case 'c':
                 speedDown(); 
                 break;

			case 'e':
				drive(0, 0); 
                break;

			case 'q':
				this->agent->setRenderingMode(Agent::RENDERINGMODE_SIMPLE);
				this->agent->disconnect();
				keepHandling = false;
				break;
			case 'm':
				this->agent->setRenderingMode(Agent::RENDERINGMODE_SLEEK);
				this->agent->disconnect();
				keepHandling = false;
				break;


            case 'r':
				releaseRFID();
                break;
            case 't':
				queryNumTags();
                break;

        };

	}
}

void KeyboardSensor::speedUp() {
	speed += .1F;
}

void KeyboardSensor::speedDown() {
	speed -= .1F;
}

void KeyboardSensor::drive(double translate /* m/s */, double rotate /* rad/s? */) {
	agent->send(
			QString("DRIVE {Left %1} {Right %2}\r\n")
				.arg(translate-rotate)
				.arg(translate+rotate)
		);
}

void KeyboardSensor::releaseRFID() {
	agent->send(
			QString("SET {Type %1} {Name %2} {Opcode Release}\r\n")
				.arg("RFIDReleaser")
				.arg("Gun")
		);
}

void KeyboardSensor::queryNumTags() {
	agent->send(
			QString("SET {Type %1} {Name %2} {Opcode TagsRemaining}\r\n")
				.arg("RFIDReleaser")
				.arg("Gun")
		);
}
