#include "PositionDevice.h"

#include <iostream>

PositionDevice::PositionDevice()
	:RobotRefDevice("Position", NONE)
{
}

PositionDevice::~PositionDevice()
{
}

void PositionDevice::run() {
	
	bool go = true;
	char c;
	
	while(go) {
		
		std::cin >> c;
		
		switch(c) {
			case 'w':
				drive(.5, 0); break;
			
			case 'a':
				drive(0, .3); break;
				
			case 's':
				drive(-.5, 0); break;
				
			case 'd':
				drive(0, -.3); break;
				
			case 'e':
				drive(0, 0); break;
				
			case 'q':
				agent->stop();
				go = false;
				break;
				
			case 'g':
				agent->putCommand("GETCONF {Type RangeScanner}\r\n");
				break;

            case 'r':
				releaseRFID(); 
                break;

            case 't':
				queryNumTags(); 
                break;

        };
		
	}
}

void PositionDevice::drive(double translate /* m/s */, double rotate /* rad/s? */) {
	
	agent->putCommand(
			QString("DRIVE {Left %1} {Right %2}\r\n")
				.arg(translate-rotate)
				.arg(translate+rotate)
		);
}

void PositionDevice::releaseRFID() {
	agent->putCommand(
			QString("SET {Type %1} {Name %2} {Opcode Release}\r\n")
				.arg("RFIDReleaser")
				.arg("Gun")
		);
}

void PositionDevice::queryNumTags() {
	agent->putCommand(
			QString("SET {Type %1} {Name %2} {Opcode TagsRemaining}\r\n")
				.arg("RFIDReleaser")
				.arg("Gun")
		);
}
