#include "RFIDDevice.h"

#include <iostream>
#include <QDebug>
#include <QStringList>

#include "RFIDData.h"

const QString RFIDDevice::RFID("RFID");

RFIDDevice::RFIDDevice()
	:Device(ANY,RFID)
{
}

RFIDDevice::~RFIDDevice()
{
}


void RFIDDevice::process(QMap<QString, QString> *data) {
	RFIDData rfid;

    rfid.ID = (*data)["ID"];

    QStringList list = (*data)["Location"].split(",");
    rfid.dx = list[0].toDouble();
    rfid.dy = list[2].toDouble();
    rfid.dz = list[2].toDouble();

    qDebug() << QString("I SAW RFID TAG %1").arg(rfid.ID);

}

bool RFIDDevice::acceptsMsg(QString type) {
	return type == "SEN";
}

