#include "Sensor.h"
#include "Agent.h"

//const QString Sensor::ANYTYPE = "TYPE*";
const QString Sensor::ANYNAME = "NAME*";

Sensor::Sensor(QString type, QString name) {
	this->type = type;
	this->name = name;
	needsConfiguration = false;
}
Sensor::~Sensor() {
	needsConfiguration = false;
}

QString Sensor::getType() {
	return this->type;
}
QString Sensor::getName() {
	return this->name;
}

void Sensor::setAgent(Agent* agent) {
    this->agent = agent;

	if(needsConfiguration)
	{
		sendGetConf();
	}
}


bool Sensor::isConfMessage(QMap<QString, QString>* msg) {
    return (*msg)["MsgType"] == "CONF";
}
bool Sensor::isSensorMessage(QMap<QString, QString>* msg) {
    return (*msg)["MsgType"] == "SEN";
}
bool Sensor::isResponseMessage(QMap<QString, QString>* msg) {
    return (*msg)["MsgType"] == "RES";
}
bool Sensor::isStatusOK(QMap<QString, QString>* msg) {
    return (*msg)["Status"].toUpper() == "OK";
}
bool Sensor::isStatusFail(QMap<QString, QString>* msg) {
    return (*msg)["Status"].toUpper() == "FAILED";
}

double Sensor::getDouble(QMap<QString, QString>* msg, QString key) {
	QString val = (*msg)[key];
	if( val.length() > 0 )
		return val.toDouble();
	// riiight...
	return -999999999999999.0;
}

float Sensor::getFloat(QMap<QString, QString>* msg, QString key) {
	QString val = (*msg)[key];
	if( val.length() > 0 )
		return val.toFloat();
	// riiight...
	return -999999999999999.0f;
}

void Sensor::sendSetCommand(QString opCode) {
    this->agent->send(
		QString("SET {Type %1} {Name %2} {Opcode %3}\r\n")
			.arg(this->type)
			.arg(this->name)
            .arg(opCode)
	);
}

void Sensor::sendGetConf() {
		this->agent->send(
			QString("GETCONF {Type %1}\r\n")
			.arg(this->type)
	);
}