#include "SonarSensor.h"
#include "Agent.h"

#include <iostream>
#include <QDebug>
#include <QStringList>

const QString SonarSensor::SONAR = "Sonar";


SonarSensor::SonarSensor()
: SingleStateSensor<SonarData>(SonarSensor::SONAR, Sensor::ANYNAME)
{
    QMutexLocker lock(&this->mxdata);
    this->data.F1 = this->data.F2 = this->data.F3 = this->data.F4 = 0;
    this->data.F5 = this->data.F6 = this->data.F7 = this->data.F8 = 0;
    this->data.R1 = this->data.R2 = this->data.R3 = this->data.R4 = 0;
    this->data.R5 = this->data.R6 = this->data.R7 = this->data.R8 = 0;
}

SonarSensor::~SonarSensor() 
{
}


void SonarSensor::accept(QMap<QString, QString>* msg) {
    {
        QMutexLocker lock(&this->mxdata);
	    this->data.F1 = (*msg)["F1"].toDouble();
	    this->data.F2 = (*msg)["F2"].toDouble();
	    this->data.F3 = (*msg)["F3"].toDouble();
	    this->data.F4 = (*msg)["F4"].toDouble();
	    this->data.F5 = (*msg)["F5"].toDouble();
	    this->data.F6 = (*msg)["F6"].toDouble();
	    this->data.F7 = (*msg)["F7"].toDouble();
	    this->data.F8 = (*msg)["F8"].toDouble();
	    this->data.R1 = (*msg)["R1"].toDouble();
	    this->data.R2 = (*msg)["R2"].toDouble();
	    this->data.R3 = (*msg)["R3"].toDouble();
	    this->data.R4 = (*msg)["R4"].toDouble();
	    this->data.R5 = (*msg)["R5"].toDouble();
	    this->data.R6 = (*msg)["R6"].toDouble();
	    this->data.R7 = (*msg)["R7"].toDouble();
	    this->data.R8 = (*msg)["R8"].toDouble();
    }
    this->agent->notifyUpdate(this);
}
