#include "TouchSensor.h"
#include "Agent.h"

#include <iostream>
#include <QDebug>
#include <QStringList>

const QString TouchSensor::TOUCH = "Touch";


TouchSensor::TouchSensor()
: SingleStateSensor<TouchData>(TouchSensor::TOUCH, Sensor::ANYNAME)
{
    QMutexLocker lock(&this->mxdata);
    this->data.front = false;
}

TouchSensor::~TouchSensor() 
{
}


void TouchSensor::accept(QMap<QString, QString>* msg) {
    {
        QMutexLocker lock(&this->mxdata);
	    this->data.front = ((*msg)["Front"] == "True");
    }
    this->agent->notifyUpdate(this);
}
