#ifndef CUBEVISITOR_H_
#define CUBEVISITOR_H_



#include "Octree.hpp"

#include <vector>
#include <iostream>

#include "Cube.h"


using namespace hxa7241_graphics;


class CubeVisitor
    : public OctreeVisitor<Cube>
{

public:

    CubeVisitor();

    virtual ~CubeVisitor();


private:

    CubeVisitor(const CubeVisitor&);

    CubeVisitor& operator=(const CubeVisitor&);


protected:

    virtual void visitRoot  (const OctreeCell* pRootCell,
	                         const OctreeData& octreeData);
	virtual void visitBranch(const OctreeCell* subCells[8],
	                         const OctreeData& octreeData);
	virtual void visitLeaf  (const Array<const Cube*>& items,
	                         const OctreeData& octreeData);

};



#endif /*CUBEVISITOR_H_*/
