#ifndef COMMANDERMAINWINDOW_H
#define COMMANDERMAINWINDOW_H

#include <QMainWindow>
#include <QSplitter>

#include "controlboxstack.h"
#include "glviewcanvas.h"

class CommanderMainWindow : public QMainWindow
{
	public:
		CommanderMainWindow(QWidget * =0);
		
		void addControlCategory(QString);
		void addControlWidget(QString, QString, QWidget *);
		
		
		const GLViewCanvas* getCanvas() const { return mvGlcanvas; }
		GLViewCanvas* getCanvas() { return mvGlcanvas; }
		
	private:
	
		QSplitter * mvSplit;
		
		GLViewCanvas * mvGlcanvas;

		ControlBoxStack *mvControlBox;
};

#endif //COMMANDERMAINWINDOW_H
