#ifndef CONTROLBOXSTACK_H
#define CONTROLBOXSTACK_H

#include <QWidget>

#include <QSize>
#include <QString>
#include <QVBoxLayout>
#include <QMap>
#include <QSpacerItem>
#include <QPaintEvent>

#include "controlbox.h"

class ControlBoxStack : public QWidget
{
	Q_OBJECT
	public:
		ControlBoxStack(QWidget * = 0);
		virtual ~ControlBoxStack();

		void addWidget(QString, QString, QWidget *);
		void addCategory(QString);
		
		//QSize sizeHint() const;
		
	public slots:

		void setCategoryVisible(QString,bool);

	private:
		QVBoxLayout * mvLayout;
		
		QWidget * mvContent;
		QVBoxLayout * mvContentLayout;

		QMap<QString, ControlBox* > mvBoxDict;
};

#endif //CONTROLBOXSTACK_H
