#ifndef ROBOTWRAPPER_H_
#define ROBOTWRAPPER_H_

#include <QThread>
#include <QString>

#include "Robot.h"
#include "LaserDevice3D.h"
#include "StatusDevice.h"

#include "Map.h"


/**
 * Glue code for using the Robot in a GUI application on in general in conjunction with the Map
 */
class RobotWrapper : public QThread
{
	private:
		Map * map;
		Robot * agent;
		LaserDevice3D * device;
		StatusDevice * status;
		
		QString name;
		
		Pose3D diff(Pose3D&, Pose3D&);
	
	public:
		RobotWrapper(Robot *, LaserDevice3D *, StatusDevice *, Map *);
		virtual ~RobotWrapper();
		
		void setName(QString name) { this->name = name; }
		
		virtual void run();
};

#endif /*ROBOTWRAPPER_H_*/
