#include "controlboxhead.h"

#include <QFont>

ControlBoxHead::ControlBoxHead(QWidget* parent, QString title)
	:QWidget(parent)
{
	setPalette(QPalette(QColor(200, 200, 200)));
	setAutoFillBackground(true);
	
	mvLayout = new QHBoxLayout();
	this->setLayout(mvLayout);

	mvToggleButton = new ControlBoxHeadButton( NULL );
	mvLayout->addWidget(mvToggleButton);
	
	mvLayout->addSpacing(3);

	mvTitle = new QLabel(title, this);
	mvLayout->addWidget(mvTitle);

	mvLayout->setStretchFactor(mvToggleButton,0); //make as small as possible
	mvLayout->setStretchFactor(mvTitle,1);
	mvLayout->setSpacing(0);
	mvLayout->setMargin(0);

	connect(mvToggleButton, SIGNAL(toggleExpand(bool)), this, SIGNAL(toggled(bool)));

	setMinimumHeight(10);
	setMaximumHeight(10);

}

ControlBoxHead::~ControlBoxHead()
{
	qDebug("ControlBoxHead deconstructor called");
}


void ControlBoxHead::mouseReleaseEvent( QMouseEvent * e)
{
	mvToggleButton->putMouseEvent(e);
}

void ControlBoxHead::toggle(bool in)
{
	mvToggleButton->toggle(in);
}
