#include <QPainter>
#include <QColor>
#include <QPoint>
#include <QPolygon>

#include "ControlBoxHeadButton.h"


ControlBoxHeadButton::ControlBoxHeadButton(QWidget * parent)
	:QWidget(parent)
{
	setPalette(QPalette(QColor(200, 200, 200)));
	setAutoFillBackground(true);
	
	setMinimumSize(10,10);
	setMaximumSize(10,10);
	collapsed=false;
}

ControlBoxHeadButton::~ControlBoxHeadButton()
{
	qDebug("ControlBoxHeadButton deconstructor called");
}

void ControlBoxHeadButton::toggle(bool in)
{
	collapsed = !in;
	update();
}

void ControlBoxHeadButton::paintEvent( QPaintEvent * )
{
	QPainter p(this);
	
	QPolygon ar;
	ar.putPoints(0,3,4,2,4,7,6,4);
	
	QPolygon ar2;
	ar2.putPoints(0,3,2,4,7,4,4,6);

	p.setBrush(QColor("darkgrey"));
	p.setPen(QColor("darkgrey"));
	if(collapsed)
	{
		p.drawEllipse(rect());
		p.setBrush(QColor("white"));
		p.setPen(QColor("white"));
		p.drawPolygon(ar);
		//p.drawPixmap( QPoint(0,0), mvCollapsed );
	}
	else
	{
		p.drawEllipse(rect());
		p.setBrush(QColor("white"));
		p.setPen(QColor("white"));
		p.drawPolygon(ar2);
		//p.drawPixmap( QPoint(0,0), mvExpanded );
	}
}

void ControlBoxHeadButton::mouseReleaseEvent( QMouseEvent * )
{
	collapsed=!collapsed;

	repaint();

	emit toggleExpand(!collapsed);
}
