#include "controlboxstack.h"

#include <QtDebug>
#include <QPainter>


ControlBoxStack::ControlBoxStack(QWidget * parent)
	: QWidget(parent)
{
	mvLayout = new QVBoxLayout();
	this->setLayout(mvLayout);
	mvLayout->setSpacing(0);
	mvLayout->setMargin(0);
	
	mvContent = new QWidget();
	mvContentLayout = new QVBoxLayout();
	mvContentLayout->setSpacing(0);
	mvContentLayout->setMargin(0);
	
	mvContent->setLayout(mvContentLayout);

	mvLayout->addWidget(mvContent);
	mvLayout->addStretch(10);

	setMinimumWidth(100);
	resize(100,10);
}

ControlBoxStack::~ControlBoxStack()
{
	qDebug("ControlBoxStack deconstructor called");
}

//QSize ControlBoxStack::sizeHint() const
//{
//	return mvContentGrid->sizeHint();
//}

void ControlBoxStack::addWidget(QString inControlName, QString inWidgetName, QWidget *inWidget)
{
	ControlBox* temp = mvBoxDict[inControlName];
	if(temp)
		temp->addWidget(inWidgetName,inWidget);
}

void ControlBoxStack::addCategory(QString inName)
{
	ControlBox* temp = new ControlBox(inName,mvContent);

	mvBoxDict.insert(inName,temp);

	mvContentLayout->addWidget(temp);
	mvContentLayout->addSpacing(3);
}

void ControlBoxStack::setCategoryVisible(QString inName, bool inVisible)
{
	qDebug() << "ControlBoxStack::setCategoryVisible: called, name=" << inName << ", vis=" << inVisible;
	ControlBox* temp = mvBoxDict[inName];
	if(temp)
	{
		qDebug("ControlBoxStack::setCategoryVisible: category found");
		if( inVisible )
			temp->expand();
		else
			temp->collapse();
	}
}
