#include "PositionController.h"

#include <QPoint>

PositionController::PositionController(PositionDevice* pos)
{
	dev = pos;
	forward = 0;
	rotate = 0;
	
	setMinimumHeight(100);
	setMinimumWidth(100);
}

PositionController::~PositionController()
{
}

void PositionController::paintEvent(QPaintEvent * /*event*/) {
	QPainter painter(this);
	
	QPen red(Qt::red);
	red.setWidth(2);
	painter.setPen(red);
	
	painter.drawEllipse(rect());
	painter.drawPoint(rect().center());
	
	int w_2 = rect().width()/2;
	int h_2 = rect().height()/2;
	QPoint p(w_2 - rotate * w_2, h_2 - forward * h_2);
	
	QRect r( p.x() - 5, p.y() - 5, 10,10);
	
	QPen green(Qt::green);
	green.setWidth(2);
	painter.setPen(green);
	
	painter.drawEllipse(r);
}

void PositionController::mousePressEvent(QMouseEvent *event) {
	double w_2 = rect().width()/2;
	double h_2 = rect().height()/2;
	
	rotate = -(event->pos().x() - w_2) / w_2;
	forward = -(event->pos().y() - h_2) / h_2;
	
	drive();
	repaint();
}

void PositionController::mouseMoveEvent(QMouseEvent *event) {
	double w_2 = rect().width()/2;
	double h_2 = rect().height()/2;
	
	rotate = -(event->pos().x() - w_2) / w_2;
	forward = -(event->pos().y() - h_2) / h_2;
	
	drive();
	repaint();
}

void PositionController::drive() {
	dev->drive(forward,rotate/3.0);
}

void PositionController::mouseReleaseEvent(QMouseEvent * /*event*/) {
	
}
