#ifndef MAP_H_
#define MAP_H_

#include <QMap>
#include <QString>

#include "Trail.h"
#include "TrailObservation.h"

#include "Octree.h"

#ifdef USE_OPENGL
#include <QtOpenGL>
#include <QColor>
#endif

class Map
{
	private:
		
		QMap<QString, Trail*> trails;
		
		Octree octree;
		
	public:
		Map(float);
		virtual ~Map();
		
		void addObservation(QString, TrailObservation*);
		void addTrail(QString);
		
		void insertVictim(Point3 point) {
			octree.insertVictim(point);
		}
		
		void drawScanLine(Ray ray) {
			octree.drawScanLine(ray);
		}
		
		//query?
		
#ifdef USE_OPENGL
		void drawGL();
		void setColors(QString, QColor, QColor);
#endif
};

#endif /*MAP_H_*/
