#ifndef TRAIL_H_
#define TRAIL_H_

#include <QList>
#include <QString>

#ifdef USE_OPENGL
#include <QtOpenGL>
#include <QColor>
#endif

class Trail;

#include "TrailObservation.h"

class Trail
{
	private:
		
		QList<TrailObservation*> observations;
		QString name;
		
#ifdef USE_OPENGL
		QColor trailColor;
		QColor scanColor;
#endif
		
	public:
		Trail(QString);
		virtual ~Trail();
		
		void addObservation(TrailObservation*);
		
		// other access things
		// + optimization functions for SLAM?
		
#ifdef USE_OPENGL
		void drawGL();
		void setColors(QColor, QColor);
		
		QColor& getTrailColor() { return trailColor; }
		QColor& getScanColor() { return scanColor; }
#endif
};

#endif /*TRAIL_H_*/
