#ifndef TRAILOBSERVATION_H_
#define TRAILOBSERVATION_H_

#ifdef USE_OPENGL
#include <QtOpenGL>

#include "GLViewCanvas.h"
#endif

#include "LaserData3D.h"
#include "Util3D.h"

class TrailObservation;

#include "Trail.h"

class TrailObservation
{
	private:
		LaserData3D laser;
		
		Pose3D poseDiff;
		
		Trail* parent;
		
		// + RFID things
		
#ifdef USE_OPENGL
		GLuint displayList;
#endif
	
	public:
		TrailObservation(LaserData3D laser, Pose3D pose);
		virtual ~TrailObservation();
		
		void setParent(Trail*);
		
		const Pose3D& getPose() { return poseDiff; }
		
#ifdef USE_OPENGL
		void drawGL();
#endif
};

#endif /*TRAILOBSERVATION_H_*/
