#include "Trail.h"

#include <QListIterator>

Trail::Trail(QString name)
{
	this->name = name;
}

Trail::~Trail()
{
	QListIterator<TrailObservation*> it(observations);
	TrailObservation* obs = NULL;
	
	while(it.hasNext()) {
		obs = it.next();
		delete obs;
	}
	observations.clear();
}

void Trail::addObservation(TrailObservation* obs) {
	obs->setParent(this);
	observations.append(obs);
}

#ifdef USE_OPENGL
void Trail::drawGL() {
	QListIterator<TrailObservation*> it(observations);
	TrailObservation* obs = NULL;
	
	glPushMatrix();
	
	bool first = true;
	
	while(it.hasNext()) {
		obs = it.next();
		
		if(!first) {
			GLViewCanvas::QGLColor(getTrailColor());
			
			glBegin(GL_LINES);
				glVertex3d(0,0,0);
				glVertex3d(obs->getPose().x,obs->getPose().y,obs->getPose().z);
			glEnd();
		} else {
			first = false;
		}
		//obs->drawGL();
	}
	
	GLViewCanvas::QGLColor(getTrailColor());
	
	glBegin(GL_LINES);
		glVertex3d(-.1,.05,.05);
		glVertex3d(0,0,0);
		
		glVertex3d(-.1,-.05,.05);
		glVertex3d(0,0,0);
		
		glVertex3d(-.1,.05,-.05);
		glVertex3d(0,0,0);
		
		glVertex3d(-.1,-.05,-.05);
		glVertex3d(0,0,0);
	glEnd();
	
	GLViewCanvas::QGLColor(getScanColor());
	glPopMatrix();
}

void Trail::setColors(QColor trail, QColor scan) {
	trailColor = trail;
	scanColor = scan;
}
#endif
