#ifndef CONNECTION_H_
#define CONNECTION_H_

#include <QUuid>
#include <QByteArray>
#include <QIODevice>
#include <QThread>
#include <QMutex>

#include "XSocket.h"

class ConversationId
{
private:
	QUuid id;
	
public:
	ConversationId(QUuid);

	const QUuid& getId() const;
	QUuid& getId();
};

class Connection : public QThread
{
protected:
	XSocket* socket;
	
	bool running;
	
	void readFromSocket(QByteArray);

public:

	Connection(XSocket*);
	virtual ~Connection();
	
	virtual void disconnect();
	bool isConnected();
	
	void setQueueWhenDisconnected(bool);
	
	virtual void run();
	void stop();

	bool send(QUuid&, const QByteArray &);
	
protected:
	virtual void received(QUuid&, QByteArray) = 0;
};

#endif /*CONNECTION_H_*/
