#include <QApplication>
#include <iostream>

#include <time.h>

#include "UsarServer.h"

int main(int argc, char** argv)
{
	QApplication app(argc, argv, true);
	
	uint port = 5000;
	
	if( argc == 2 )
		port = QString(argv[1]).toUInt();

	UsarServer serv(port);
	
	char c =0;
	
	while(c!='q')
	{
		std::cin >> c;
	
		switch(c)
		{
			case 'm':
				{
					serv.disconnectClients();
					serv.disconnect(); // make sure no more modifications to the map
					int pxPerMeter;
					std::cout << "please specify pixel/meters:" << std::endl;
					std::cin >> pxPerMeter;

					{
						clock_t start = clock();

						serv.saveRFIDs("rfidbefore.log");
						serv.saveVictims("victimbefore.log");
						serv.saveMap(pxPerMeter,"mapbefore.png");

						clock_t end = clock();

						qDebug() << "printed original map took " << ((float)(end-start))/CLOCKS_PER_SEC << " sec";
					}

					{
						clock_t start = clock();

						// here is THA MAGIC ;-p
						serv.mergeIslands();

						serv.saveRFIDs("rfidafter.log");
						serv.saveVictims("victimafter.log");
						serv.saveMap(pxPerMeter,"mapafter.png");

						clock_t end = clock();

						qDebug() << "printed merged map took " << ((float)(end-start))/CLOCKS_PER_SEC << " sec";
					}
				}
				break;
		};
	}
	
	serv.disconnectClients();
	serv.disconnect();
}